# -*- coding: utf-8 -*-
##------------------------------------------
##  Face  recognition test program Ver 0.01
##
##               2022.06.15 Masahiro Izutsu
##------------------------------------------
## face_rec_test1.py

import cv2
import face_recognition

# 登録する顔画像
IMAGE_BASE = 'face_img/okegawa_1.jpg'
#IMAGE_BASE = 'face_img/nitta_1.jpg'
#IMAGE_BASE = 'face_img/izutsu_1.jpg'

# テストする顔の画像
IMAGE_TEST = 'face_test/okegawa_2.jpg'
#IMAGE_TEST = 'face_test/okegawa_3.jpg'
#IMAGE_TEST = 'face_test/nitta_2.jpg'
#IMAGE_TEST = 'face_test/nitta_3.jpg'
#IMAGE_TEST = 'face_test/izutsu_2.jpg'
#IMAGE_TEST = 'face_test/izutsu_3.jpg'
#IMAGE_TEST = 'face_test/kenta_1.jpg'

# step1 画像読み込みとコンバート
img_elon = face_recognition.load_image_file(IMAGE_BASE)
img_elon = cv2.cvtColor(img_elon, cv2.COLOR_BGR2RGB)
img_test = face_recognition.load_image_file(IMAGE_TEST)
img_test = cv2.cvtColor(img_test, cv2.COLOR_BGR2RGB)

# step2 顔認証
face_loc = face_recognition.face_locations(img_elon)[0]

# 128次元の顔エンコーディングのリスト
encode_elon = face_recognition.face_encodings(img_elon)[0]
cv2.rectangle(img_elon, (face_loc[3], face_loc[0]), (face_loc[1], face_loc[2]), (255, 0, 255), 2)

face_loc_test = face_recognition.face_locations(img_test)[0]
encode_elon_test = face_recognition.face_encodings(img_test)[0]

# print(encode_elon_test)
cv2.rectangle(img_test, (face_loc_test[3], face_loc_test[0]), (face_loc_test[1], face_loc_test[2]), (255, 0, 255), 2)

# ２つの画像が同一人物かの判定
results = face_recognition.compare_faces([encode_elon], encode_elon_test)
# 値が小さい程マッチしている
face_dis = face_recognition.face_distance([encode_elon], encode_elon_test)

print('image0: ', IMAGE_BASE)
print('image1: ', IMAGE_TEST)
print(' ', face_dis <= 0.48, face_dis)

h0, w0 = img_elon.shape[:2]
h1, w1 = img_test.shape[:2]
img0 = cv2.resize(img_elon, dsize = (int(w0 / 2), int(h0 / 2)))
img1 = cv2.resize(img_test, dsize = (int(w1 / 2), int(h1 / 2)))

# 横に2つ表示して5秒でwindowが閉じる設定
cv2.startWindowThread()
cv2.namedWindow(IMAGE_BASE, flags=cv2.WINDOW_AUTOSIZE | cv2.WINDOW_GUI_NORMAL) 
cv2.imshow(IMAGE_BASE, img0)
cv2.moveWindow(IMAGE_BASE, 100, 0)
cv2.namedWindow(IMAGE_TEST, flags=cv2.WINDOW_AUTOSIZE | cv2.WINDOW_GUI_NORMAL) 
cv2.imshow(IMAGE_TEST, img1)
cv2.moveWindow(IMAGE_TEST, 100 + int(w0 / 2), 0)
cv2.waitKey(5000)

cv2.waitKey(1)
cv2.destroyAllWindows()
cv2.waitKey(1)
