import numpy as np
import cv2
from insightface.app import FaceAnalysis

capture = cv2.VideoCapture(0)
app = FaceAnalysis()
app.prepare(ctx_id=0, det_size=(640, 640))
 
win_name = "Inface test"
while True:
    ret, frame = capture.read()
    orgHeight, orgWidth = frame.shape[:2]
    size = (int(orgWidth/2), int(orgHeight/2))
    image = cv2.resize(frame, size)

    faces = app.get(np.asarray(image))
    rimg = app.draw_on(image, faces)

    cv2.namedWindow(win_name, flags=cv2.WINDOW_AUTOSIZE | cv2.WINDOW_GUI_NORMAL) 
    cv2.imshow(win_name, rimg)
       
    if cv2.waitKey(33) >= 0:
        break

cv2.destroyAllWindows()
